// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/Titles.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.marker;


@SuppressWarnings("fallthrough")
public class Titles extends JFlexAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int inContainer = 2;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1, 1
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\36\u0200\1\u0300\1\u0400\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\1\1\2\22\0\1\1"+
    "\5\0\1\3\10\0\1\4\12\0\1\5\1\6\1\7"+
    "\1\0\1\10\2\0\1\11\1\12\1\13\1\0\1\14"+
    "\1\15\1\16\1\17\1\20\1\0\1\21\1\22\1\23"+
    "\1\24\1\25\1\26\1\0\1\27\1\30\1\31\1\32"+
    "\4\0\1\33\6\0\1\11\1\12\1\13\1\0\1\14"+
    "\1\15\1\16\1\17\1\20\1\0\1\21\1\22\1\23"+
    "\1\24\1\25\1\26\1\0\1\27\1\30\1\31\1\32"+
    "\4\0\1\33\265\0\2\20\115\0\1\30\u0182\0\1\1"+
    "\u0127\0\1\21\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1280];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\5\0\2\1\1\2\1\3\2\2\66\0\1\3\24\0"+
    "\1\4\50\0\1\5\163\0\1\6\243\0\1\7\2\0"+
    "\1\7\44\0\1\7\132\0\1\10\16\0\1\11\72\0"+
    "\1\12\10\0";

  private static int [] zzUnpackAction() {
    int [] result = new int[621];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\34\0\70\0\124\0\160\0\214\0\250\0\214"+
    "\0\304\0\340\0\374\0\u0118\0\u0134\0\u0150\0\u016c\0\340"+
    "\0\u0188\0\u01a4\0\u01c0\0\u01dc\0\u01f8\0\u0214\0\u0230\0\u024c"+
    "\0\u0268\0\u0284\0\u02a0\0\u02bc\0\u02d8\0\u02f4\0\u0310\0\u032c"+
    "\0\u0348\0\u0364\0\u0380\0\u039c\0\u03b8\0\u03d4\0\u03f0\0\u040c"+
    "\0\u0428\0\u0444\0\u0460\0\u047c\0\u0498\0\u04b4\0\u04d0\0\u04ec"+
    "\0\u0508\0\u0524\0\u0540\0\u055c\0\u0578\0\u0594\0\u05b0\0\u05cc"+
    "\0\u05e8\0\u0604\0\u0620\0\u063c\0\u0658\0\u0674\0\u0690\0\u06ac"+
    "\0\u06c8\0\214\0\u06e4\0\u0700\0\u071c\0\u0738\0\u0754\0\u0770"+
    "\0\u078c\0\u07a8\0\u07c4\0\u07e0\0\u07fc\0\u0818\0\u0834\0\u0850"+
    "\0\u086c\0\u0888\0\u08a4\0\u08c0\0\u08dc\0\u08f8\0\u0914\0\u0930"+
    "\0\u094c\0\u0968\0\u0984\0\u09a0\0\u09bc\0\u09d8\0\u09f4\0\u0a10"+
    "\0\u0a2c\0\u0a48\0\u0a64\0\u0a80\0\u0a9c\0\u0ab8\0\u0ad4\0\u0af0"+
    "\0\u0b0c\0\u0b28\0\u0b44\0\u0b60\0\u0b7c\0\u0b98\0\u0bb4\0\u0bd0"+
    "\0\u0bec\0\u0c08\0\u0c24\0\u0c40\0\u0c5c\0\u0c78\0\u0c94\0\u0cb0"+
    "\0\u0ccc\0\u0ce8\0\u0d04\0\u0d20\0\u0914\0\u0d3c\0\u0d58\0\214"+
    "\0\u0d74\0\u0d90\0\u0dac\0\u0dc8\0\u0de4\0\u0e00\0\u0e1c\0\u0e38"+
    "\0\u0e54\0\u0e70\0\u0e8c\0\u0ea8\0\u0ec4\0\u0ee0\0\u0efc\0\u0f18"+
    "\0\u0f34\0\u0f50\0\u0f6c\0\u0f88\0\u0fa4\0\u0fc0\0\u0fdc\0\u0ff8"+
    "\0\u1014\0\u1030\0\u104c\0\u1068\0\u1084\0\u10a0\0\u10bc\0\u10d8"+
    "\0\u10f4\0\u1110\0\u112c\0\u1148\0\u1164\0\u1180\0\u119c\0\u11b8"+
    "\0\u11d4\0\u11f0\0\u120c\0\u1228\0\u1244\0\u1260\0\u127c\0\u1298"+
    "\0\u12b4\0\u12d0\0\u12ec\0\u1308\0\u1324\0\u1340\0\u135c\0\u1378"+
    "\0\u1394\0\u13b0\0\u13cc\0\u13e8\0\u1404\0\u1420\0\u143c\0\u1458"+
    "\0\u1474\0\u1490\0\u14ac\0\u14c8\0\u14e4\0\u1500\0\u151c\0\u1538"+
    "\0\u1554\0\u1570\0\u158c\0\u15a8\0\u15c4\0\u15e0\0\u15fc\0\u1618"+
    "\0\u1634\0\u1650\0\u166c\0\u1688\0\u16a4\0\u16c0\0\u16dc\0\u16f8"+
    "\0\u1714\0\u1730\0\u174c\0\u1768\0\u1784\0\u17a0\0\u17bc\0\u17d8"+
    "\0\u17f4\0\u1810\0\u182c\0\u1848\0\u1864\0\u1880\0\u189c\0\u18b8"+
    "\0\u18d4\0\u18f0\0\u190c\0\u1928\0\u1944\0\u1960\0\u197c\0\u1998"+
    "\0\u19b4\0\u19d0\0\u19ec\0\214\0\u1a08\0\u1a24\0\u1a40\0\u1a5c"+
    "\0\u1a78\0\u1a94\0\u1ab0\0\u1acc\0\u1ae8\0\u1b04\0\u1b20\0\u1b3c"+
    "\0\u1b58\0\u1b74\0\u1b90\0\u1bac\0\u1bc8\0\u1be4\0\u1c00\0\u1c1c"+
    "\0\u1c38\0\u1c54\0\u1c70\0\u1c8c\0\u1ca8\0\u1cc4\0\u1ce0\0\u1cfc"+
    "\0\u1d18\0\u1d34\0\u1d50\0\u1d6c\0\u1d88\0\u1da4\0\u1dc0\0\u1ddc"+
    "\0\u1df8\0\u1e14\0\u1e30\0\u1e4c\0\u1e68\0\u1e84\0\u1ea0\0\u1ebc"+
    "\0\u1ed8\0\u1ef4\0\u1f10\0\u1f2c\0\u1f48\0\u1f64\0\u1f80\0\u1f9c"+
    "\0\u1fb8\0\u1fd4\0\u1ff0\0\u200c\0\u2028\0\u2044\0\u2060\0\u207c"+
    "\0\u2098\0\u20b4\0\u20d0\0\u20ec\0\u2108\0\u2124\0\u2140\0\u215c"+
    "\0\u2178\0\u2194\0\u21b0\0\u21cc\0\u21e8\0\u2204\0\u2220\0\u223c"+
    "\0\u2258\0\u2274\0\u2290\0\u22ac\0\u22c8\0\u22e4\0\u2300\0\u231c"+
    "\0\u2338\0\u2354\0\u2370\0\u238c\0\u23a8\0\u23c4\0\u23e0\0\u23fc"+
    "\0\u2418\0\u2434\0\u2450\0\u246c\0\u2488\0\u24a4\0\u24c0\0\u24dc"+
    "\0\u24f8\0\u2514\0\u2530\0\u254c\0\u2568\0\u2584\0\u25a0\0\u25bc"+
    "\0\u25d8\0\u25f4\0\u2610\0\u262c\0\u2648\0\u2664\0\u2680\0\u269c"+
    "\0\u26b8\0\u26d4\0\u26f0\0\u270c\0\u2728\0\u2744\0\u2760\0\u277c"+
    "\0\u2798\0\u27b4\0\u27d0\0\u27ec\0\u2808\0\u2824\0\u2840\0\u285c"+
    "\0\u2878\0\u2894\0\u28b0\0\u28cc\0\u28e8\0\u2904\0\u2920\0\u293c"+
    "\0\u2958\0\u2974\0\u2990\0\u29ac\0\u29c8\0\u29e4\0\u2a00\0\u2a1c"+
    "\0\u2a38\0\u2a54\0\u2a70\0\u2a8c\0\u2aa8\0\u2ac4\0\u2ae0\0\u2afc"+
    "\0\u2b18\0\u2b34\0\u2b50\0\u2b6c\0\u2b88\0\u2ba4\0\u2bc0\0\u2bdc"+
    "\0\u2bf8\0\u2c14\0\u2c30\0\u2c4c\0\u2c68\0\u2c84\0\u2ca0\0\u2cbc"+
    "\0\u2cd8\0\u2cf4\0\u2d10\0\u2d2c\0\u2d48\0\u2d64\0\u2d80\0\u2d9c"+
    "\0\u2db8\0\u2dd4\0\u2df0\0\u2e0c\0\u2e28\0\u2e44\0\u2e60\0\u2e7c"+
    "\0\u2e98\0\u2eb4\0\u2ed0\0\u2eec\0\u2f08\0\u2f24\0\u2f40\0\u2f5c"+
    "\0\u2f78\0\u2f94\0\u2fb0\0\u2fcc\0\u2fe8\0\u3004\0\u3020\0\u303c"+
    "\0\u3058\0\u3074\0\u3090\0\u30ac\0\u30c8\0\u30e4\0\u3100\0\u311c"+
    "\0\u3138\0\u3154\0\u3170\0\u318c\0\u31a8\0\u31c4\0\u31e0\0\u31fc"+
    "\0\u3218\0\u3234\0\u3250\0\214\0\u326c\0\u3288\0\u32a4\0\u32c0"+
    "\0\u32dc\0\u32f8\0\u3314\0\u3330\0\u334c\0\u3368\0\u3384\0\u33a0"+
    "\0\u33bc\0\u33d8\0\u33f4\0\u3410\0\u342c\0\u3448\0\u3464\0\u3480"+
    "\0\u349c\0\u34b8\0\u34d4\0\u34f0\0\u350c\0\u3528\0\u3544\0\u3560"+
    "\0\u357c\0\u3598\0\u35b4\0\u35d0\0\u35ec\0\u3608\0\u3624\0\u3640"+
    "\0\u365c\0\u3678\0\u3694\0\u36b0\0\u36cc\0\u36e8\0\u3704\0\u3720"+
    "\0\u373c\0\u3758\0\u3774\0\u3790\0\u37ac\0\u37c8\0\u37e4\0\u3800"+
    "\0\u381c\0\u3838\0\u3854\0\u3870\0\u388c\0\u38a8\0\u38c4\0\u38e0"+
    "\0\u38fc\0\u3918\0\u3934\0\u3950\0\u396c\0\u3988\0\u39a4\0\u39c0"+
    "\0\u39dc\0\u39f8\0\214\0\u3a14\0\u3a30\0\u3a4c\0\u3a68\0\u2ca0"+
    "\0\u3a84\0\u3aa0\0\u3abc\0\u3ad8\0\u3af4\0\u3b10\0\u3b2c\0\u3b48"+
    "\0\u3b64\0\214\0\u3b80\0\u3b9c\0\u3bb8\0\u3bd4\0\u3bf0\0\u3c0c"+
    "\0\u3c28\0\u3c44\0\u3c60\0\u3c7c\0\u3c98\0\u3cb4\0\u3cd0\0\u3cec"+
    "\0\u3d08\0\u3d24\0\u3d40\0\u3d5c\0\u3d78\0\u3d94\0\u3db0\0\u3dcc"+
    "\0\u3de8\0\u3e04\0\u3e20\0\u3e3c\0\u3e58\0\u3e74\0\u3e90\0\u3eac"+
    "\0\u3ec8\0\u3ee4\0\u3f00\0\u3f1c\0\u3f38\0\u3f54\0\u3f70\0\u3f8c"+
    "\0\u3fa8\0\u3fc4\0\u3fe0\0\u3ffc\0\u4018\0\u4034\0\u4050\0\u406c"+
    "\0\u4088\0\u40a4\0\u40c0\0\u40dc\0\u40f8\0\u4114\0\u4130\0\u414c"+
    "\0\u4168\0\u4184\0\u41a0\0\u41bc\0\214\0\u41d8\0\u41f4\0\u4210"+
    "\0\u422c\0\u4248\0\u4264\0\u4280\0\u429c";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[621];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\7\6\1\7\24\6\1\10\2\11\1\12\3\10\1\13"+
    "\24\10\7\0\1\14\34\0\1\15\32\0\1\16\103\0"+
    "\1\17\11\0\2\11\1\20\3\0\1\21\50\0\1\22"+
    "\13\0\1\23\12\0\1\24\3\0\1\25\33\0\1\26"+
    "\10\0\10\27\1\0\1\30\22\27\23\0\1\31\37\0"+
    "\1\32\10\0\1\33\16\0\1\25\22\0\1\34\40\0"+
    "\1\35\21\0\1\36\55\0\1\37\33\0\1\40\4\0"+
    "\1\27\1\41\4\27\1\42\1\27\1\0\1\43\2\27"+
    "\1\44\10\27\1\45\7\27\1\41\4\27\1\42\1\27"+
    "\1\0\1\43\2\27\1\44\6\27\1\46\1\27\1\45"+
    "\6\27\27\0\1\47\25\0\1\50\31\0\1\51\44\0"+
    "\1\52\10\0\1\53\40\0\1\54\13\0\1\55\26\0"+
    "\1\56\33\0\1\57\12\0\1\27\1\41\4\27\1\42"+
    "\1\27\1\0\1\60\2\27\1\44\10\27\1\45\7\27"+
    "\1\41\4\27\1\42\1\27\1\0\1\43\2\27\1\44"+
    "\10\27\1\45\1\61\6\27\1\41\4\27\1\42\1\27"+
    "\1\0\1\43\2\27\1\44\10\27\1\45\1\27\1\62"+
    "\5\27\1\41\4\27\1\42\1\27\1\0\1\43\2\27"+
    "\1\44\7\27\1\63\1\45\3\27\1\64\3\27\1\41"+
    "\4\27\1\42\1\27\1\0\1\43\2\27\1\44\1\65"+
    "\4\27\1\66\2\27\1\45\1\67\1\70\5\27\1\41"+
    "\4\27\1\42\1\27\1\0\1\43\2\27\1\44\6\27"+
    "\1\71\1\27\1\45\6\27\21\0\1\72\17\0\1\73"+
    "\33\0\1\74\54\0\1\75\33\0\1\76\34\0\1\77"+
    "\5\0\1\100\1\0\1\101\4\0\1\102\30\0\1\103"+
    "\33\0\1\104\26\0\1\27\1\41\4\27\1\42\1\27"+
    "\1\0\1\43\2\27\1\44\6\27\1\46\1\27\1\45"+
    "\1\27\1\62\5\27\1\41\4\27\1\42\1\27\1\0"+
    "\1\43\2\27\1\44\10\27\1\45\2\27\1\105\4\27"+
    "\1\41\4\27\1\42\1\27\1\0\1\43\2\27\1\106"+
    "\10\27\1\45\7\27\1\41\4\27\1\42\1\27\1\0"+
    "\1\43\2\27\1\44\10\27\1\107\7\27\1\41\4\27"+
    "\1\42\1\27\1\0\1\43\2\27\1\44\10\27\1\45"+
    "\1\27\1\110\5\27\1\41\4\27\1\42\1\27\1\0"+
    "\1\111\2\27\1\44\10\27\1\45\7\27\1\41\4\27"+
    "\1\42\1\27\1\0\1\43\2\27\1\44\10\27\1\112"+
    "\7\27\1\41\4\27\1\42\1\27\1\0\1\113\2\27"+
    "\1\44\10\27\1\45\7\27\1\41\4\27\1\42\1\27"+
    "\1\0\1\43\1\114\1\27\1\115\10\27\1\45\7\27"+
    "\1\41\4\27\1\42\1\27\1\0\1\43\2\27\1\44"+
    "\10\27\1\116\6\27\5\0\1\117\37\0\1\120\1\0"+
    "\1\121\6\0\1\122\3\0\1\123\1\0\1\124\1\125"+
    "\30\0\1\126\13\0\1\11\35\0\1\127\27\0\1\130"+
    "\27\0\10\100\1\102\23\100\24\0\1\131\20\0\1\132"+
    "\1\0\1\133\6\0\1\134\1\0\1\135\1\0\1\136"+
    "\1\0\1\137\1\140\13\0\1\141\1\0\1\142\6\0"+
    "\1\143\3\0\1\144\1\0\1\145\1\146\2\0\1\27"+
    "\1\41\4\27\1\42\1\27\1\0\1\43\1\147\1\27"+
    "\1\44\10\27\1\45\7\27\1\41\4\27\1\42\1\27"+
    "\1\0\1\43\2\27\1\44\7\27\1\63\1\45\3\27"+
    "\1\150\3\27\1\41\4\27\1\42\1\27\1\0\1\43"+
    "\2\27\1\44\1\65\2\27\1\151\1\27\1\66\2\27"+
    "\1\45\1\67\1\70\5\27\1\41\4\27\1\42\1\27"+
    "\1\0\1\152\2\27\1\44\10\27\1\45\7\27\1\41"+
    "\4\27\1\42\1\27\1\0\1\43\2\27\1\44\10\27"+
    "\1\45\1\27\1\153\5\27\1\41\4\27\1\42\1\27"+
    "\1\0\1\43\1\27\1\154\1\44\1\65\4\27\1\66"+
    "\2\27\1\45\1\67\1\70\1\27\1\155\3\27\1\41"+
    "\4\27\1\42\1\27\1\0\1\43\1\27\1\156\1\44"+
    "\10\27\1\45\1\27\1\62\5\27\1\41\4\27\1\42"+
    "\1\27\1\0\1\43\2\27\1\44\3\27\1\157\4\27"+
    "\1\45\7\27\1\41\4\27\1\42\1\27\1\0\1\43"+
    "\2\27\1\44\6\27\1\160\1\63\1\45\3\27\1\64"+
    "\3\27\1\41\4\27\1\42\1\27\1\0\1\43\1\27"+
    "\1\156\1\44\1\65\4\27\1\66\2\27\1\45\1\67"+
    "\1\70\4\27\11\0\1\161\1\0\1\162\6\0\1\163"+
    "\3\0\1\164\1\0\1\165\1\166\31\0\1\167\15\0"+
    "\1\170\42\0\1\171\24\0\1\172\36\0\1\173\37\0"+
    "\1\174\23\0\1\175\24\0\2\175\1\176\3\0\1\177"+
    "\34\0\1\200\35\0\1\201\50\0\1\202\15\0\1\203"+
    "\13\0\1\204\22\0\1\205\3\0\1\206\45\0\1\207"+
    "\12\0\1\210\36\0\1\211\10\0\1\212\26\0\1\213"+
    "\42\0\1\214\15\0\1\215\42\0\1\216\24\0\1\217"+
    "\36\0\1\220\37\0\1\221\13\0\1\27\1\41\4\27"+
    "\1\42\1\27\1\0\1\43\2\27\1\44\7\27\1\222"+
    "\1\45\7\27\1\41\4\27\1\42\1\27\1\0\1\43"+
    "\2\27\1\44\10\27\1\45\1\27\1\110\1\27\1\223"+
    "\3\27\1\41\4\27\1\42\1\27\1\0\1\43\2\27"+
    "\1\44\10\27\1\45\5\27\1\224\1\27\1\41\4\27"+
    "\1\42\1\27\1\0\1\43\2\27\1\44\10\27\1\45"+
    "\1\156\1\62\5\27\1\41\4\27\1\42\1\27\1\0"+
    "\1\43\2\27\1\106\1\27\1\225\6\27\1\45\7\27"+
    "\1\41\4\27\1\42\1\27\1\0\1\43\2\27\1\44"+
    "\3\27\1\226\4\27\1\45\7\27\1\41\4\27\1\42"+
    "\1\27\1\0\1\43\2\27\1\44\3\27\1\227\4\27"+
    "\1\45\7\27\1\41\3\27\1\230\1\42\1\27\1\0"+
    "\1\43\2\27\1\44\10\27\1\45\7\27\1\41\4\27"+
    "\1\42\1\27\1\0\1\43\2\27\1\44\5\27\1\156"+
    "\2\27\1\45\7\27\1\41\4\27\1\42\1\27\1\0"+
    "\1\43\2\27\1\44\10\27\1\45\4\27\1\231\1\27"+
    "\27\0\1\232\15\0\1\233\42\0\1\234\24\0\1\235"+
    "\36\0\1\236\37\0\1\237\44\0\1\240\30\0\1\241"+
    "\17\0\1\242\50\0\1\243\37\0\1\244\31\0\1\245"+
    "\26\0\1\246\32\0\1\25\40\0\1\247\34\0\1\250"+
    "\30\0\1\251\30\0\1\252\41\0\1\253\14\0\1\254"+
    "\44\0\1\255\37\0\1\256\37\0\1\257\31\0\1\260"+
    "\33\0\1\261\33\0\1\262\30\0\1\263\17\0\1\264"+
    "\50\0\1\265\37\0\1\266\31\0\1\267\2\0\1\27"+
    "\1\41\1\27\1\41\2\27\1\42\1\27\1\0\1\43"+
    "\2\27\1\44\10\27\1\45\7\27\1\41\4\27\1\42"+
    "\1\27\1\0\1\43\2\27\1\270\10\27\1\45\7\27"+
    "\1\41\4\27\1\42\1\27\1\0\1\43\2\27\1\271"+
    "\10\27\1\45\7\27\1\41\4\27\1\42\1\27\1\0"+
    "\1\272\2\27\1\44\10\27\1\45\7\27\1\41\4\27"+
    "\1\42\1\27\1\0\1\43\2\27\1\44\10\27\1\45"+
    "\3\27\1\273\3\27\1\41\4\27\1\42\1\27\1\0"+
    "\1\43\2\27\1\44\10\27\1\45\3\27\1\156\3\27"+
    "\1\41\4\27\1\42\1\27\1\0\1\43\2\27\1\44"+
    "\4\27\1\274\3\27\1\45\7\27\1\41\4\27\1\42"+
    "\1\27\1\0\1\43\2\27\1\44\7\27\1\275\1\45"+
    "\6\27\31\0\1\276\30\0\1\277\17\0\1\300\50\0"+
    "\1\301\37\0\1\302\31\0\1\303\22\0\1\304\40\0"+
    "\1\305\35\0\1\241\35\0\1\306\22\0\1\307\40\0"+
    "\1\310\20\0\1\311\47\0\1\312\25\0\1\313\40\0"+
    "\1\314\31\0\1\315\41\0\1\316\31\0\1\251\20\0"+
    "\1\254\30\0\1\317\17\0\1\320\22\0\1\321\44\0"+
    "\1\322\27\0\1\323\26\0\1\324\40\0\1\325\35\0"+
    "\1\263\35\0\1\326\22\0\1\327\40\0\1\330\6\0"+
    "\1\27\1\41\4\27\1\42\1\27\1\0\1\43\2\27"+
    "\1\44\5\27\1\156\1\27\1\63\1\45\3\27\1\64"+
    "\3\27\1\41\4\27\1\42\1\27\1\0\1\43\2\27"+
    "\1\44\7\27\1\63\1\45\2\27\1\156\1\64\3\27"+
    "\1\41\4\27\1\42\1\27\1\0\1\43\2\27\1\44"+
    "\10\27\1\45\1\27\1\331\5\27\1\41\4\27\1\42"+
    "\1\27\1\0\1\43\2\27\1\44\10\27\1\45\1\27"+
    "\1\332\5\27\1\41\4\27\1\42\1\27\1\0\1\43"+
    "\2\27\1\44\10\27\1\45\1\27\1\333\5\27\1\41"+
    "\3\27\1\230\1\42\1\27\1\0\1\43\2\27\1\44"+
    "\10\27\1\334\6\27\20\0\1\335\40\0\1\336\35\0"+
    "\1\277\35\0\1\337\22\0\1\340\40\0\1\341\21\0"+
    "\1\245\20\0\10\342\1\0\23\342\14\0\1\305\44\0"+
    "\1\343\30\0\1\241\41\0\1\344\11\0\1\100\40\0"+
    "\1\261\20\0\10\345\1\0\23\345\11\0\1\346\36\0"+
    "\1\347\35\0\1\350\31\0\1\314\44\0\1\351\33\0"+
    "\1\352\30\0\1\251\24\0\1\267\20\0\10\353\1\0"+
    "\23\353\14\0\1\325\44\0\1\354\30\0\1\263\11\0"+
    "\1\27\1\41\4\27\1\42\1\27\1\0\1\152\2\27"+
    "\1\106\10\27\1\45\7\27\1\41\4\27\1\42\1\27"+
    "\1\0\1\355\2\27\1\44\10\27\1\45\7\27\1\41"+
    "\4\27\1\42\1\27\1\0\1\43\2\27\1\44\6\27"+
    "\1\356\1\27\1\45\7\27\1\41\4\27\1\42\1\27"+
    "\1\0\1\43\2\27\1\44\1\65\4\27\1\66\2\27"+
    "\1\45\1\67\1\70\1\27\1\357\2\27\13\0\1\303"+
    "\20\0\10\360\1\0\23\360\14\0\1\336\44\0\1\361"+
    "\30\0\1\277\11\0\10\342\1\362\23\342\24\0\1\306"+
    "\35\0\1\363\5\0\10\345\1\364\23\345\1\0\1\314"+
    "\1\0\1\365\4\0\1\364\52\0\1\366\33\0\1\367"+
    "\30\0\1\320\33\0\1\135\7\0\10\353\1\370\23\353"+
    "\24\0\1\326\7\0\1\27\1\41\3\27\1\230\1\42"+
    "\1\27\1\0\1\43\2\27\1\44\10\27\1\45\1\27"+
    "\1\62\5\27\1\41\4\27\1\42\1\371\1\0\1\43"+
    "\2\27\1\44\10\27\1\45\7\27\1\41\4\27\1\42"+
    "\1\27\1\0\1\43\2\27\1\44\10\27\1\45\3\27"+
    "\1\372\2\27\10\360\1\373\23\360\24\0\1\337\16\0"+
    "\1\374\32\0\1\175\51\0\1\375\20\0\1\314\33\0"+
    "\1\376\31\0\1\377\24\0\1\27\1\u0100\1\371\3\27"+
    "\1\u0101\1\27\1\0\1\43\2\27\1\44\10\27\1\45"+
    "\7\27\1\41\4\27\1\42\1\27\1\0\1\43\2\27"+
    "\1\44\10\27\1\u0102\6\27\7\0\1\u0103\43\0\1\u0104"+
    "\3\0\1\u0105\22\0\1\u0106\36\0\1\251\35\0\1\u0107"+
    "\3\0\1\u0108\10\0\1\27\1\u0100\1\371\3\27\1\u0101"+
    "\1\27\1\0\1\60\2\27\1\44\10\27\1\45\7\27"+
    "\1\41\4\27\1\42\1\27\1\0\1\43\2\27\1\44"+
    "\10\27\1\45\1\u0109\6\27\1\41\4\27\1\42\1\27"+
    "\1\0\1\43\2\27\1\44\1\65\4\27\1\66\2\27"+
    "\1\45\1\67\1\70\1\156\3\27\17\0\1\u010a\3\0"+
    "\1\u010b\15\0\1\u010c\55\0\1\u010d\34\0\1\u010e\10\0"+
    "\1\u010f\55\0\1\u0110\4\0\1\27\1\41\4\27\1\42"+
    "\1\27\1\0\1\43\2\27\1\44\10\27\1\45\2\27"+
    "\1\u0111\3\27\5\0\1\u0112\55\0\1\u0113\32\0\1\u0114"+
    "\26\0\1\u0115\40\0\1\u0116\33\0\1\u0117\26\0\1\u0118"+
    "\12\0\1\27\1\41\4\27\1\42\1\27\1\0\1\43"+
    "\1\u0119\1\27\1\44\10\27\1\45\6\27\26\0\1\u011a"+
    "\26\0\1\u011b\13\0\1\u011c\1\0\1\u011d\4\0\1\u011e"+
    "\30\0\1\u011f\34\0\1\314\26\0\1\u0120\1\0\1\u0121"+
    "\4\0\1\u0122\30\0\1\u0123\26\0\1\27\1\41\4\27"+
    "\1\42\1\27\1\0\1\43\2\27\1\44\7\27\1\u0124"+
    "\1\45\6\27\1\0\1\u0125\1\0\1\u0126\4\0\1\u0127"+
    "\30\0\1\u0128\26\0\10\u011c\1\u011e\23\u011c\24\0\1\u0129"+
    "\16\0\1\u012a\44\0\1\u012b\13\0\10\u0120\1\u0122\23\u0120"+
    "\24\0\1\u012c\16\0\1\u012d\44\0\1\u012e\13\0\1\27"+
    "\1\41\1\27\1\u0100\2\27\1\42\1\27\1\0\1\43"+
    "\2\27\1\44\10\27\1\45\6\27\10\u0125\1\u0127\23\u0125"+
    "\24\0\1\u012f\16\0\1\u0130\44\0\1\u0131\25\0\1\u0132"+
    "\44\0\1\u0105\34\0\1\u0133\21\0\1\u0134\44\0\1\u0108"+
    "\34\0\1\u0135\21\0\1\u0136\44\0\1\u010b\34\0\1\u0137"+
    "\37\0\1\u0138\34\0\1\u0139\32\0\1\u013a\34\0\1\u013b"+
    "\32\0\1\u013c\34\0\1\u013d\30\0\1\u013e\21\0\1\u013f"+
    "\45\0\1\u0140\21\0\1\u0141\45\0\1\u0142\21\0\1\u0143"+
    "\25\0\1\u011c\55\0\1\u0144\11\0\1\u0120\55\0\1\u0145"+
    "\11\0\1\u0125\55\0\1\u0146\34\0\1\u0147\33\0\1\u0148"+
    "\33\0\1\u0149\13\0\1\u014a\33\0\1\u014b\33\0\1\u014c"+
    "\55\0\1\u014d\33\0\1\u014e\33\0\1\u014f\20\0\1\u0150"+
    "\33\0\1\u0151\33\0\1\u0152\40\0\1\u0153\33\0\1\u0154"+
    "\33\0\1\u0155\32\0\1\u0156\33\0\1\u0157\33\0\1\u0158"+
    "\23\0\1\u0159\33\0\1\u015a\33\0\1\u015b\27\0\1\u015c"+
    "\33\0\1\u015d\33\0\1\u015e\23\0\7\u015f\1\0\24\u015f"+
    "\7\u0160\1\0\24\u0160\7\u0161\1\0\24\u0161\7\u015f\1\u0162"+
    "\24\u015f\7\u0160\1\u0163\24\u0160\7\u0161\1\u0164\24\u0161\4\0"+
    "\1\u0165\33\0\1\u0166\33\0\1\u0167\52\0\1\u0168\33\0"+
    "\1\u0169\33\0\1\u016a\37\0\1\u016b\33\0\1\u016c\33\0"+
    "\1\u016d\25\0\1\u016e\33\0\1\u016f\33\0\1\u0170\17\0"+
    "\1\u0171\33\0\1\u0172\33\0\1\u0173\46\0\1\u0174\33\0"+
    "\1\u0175\33\0\1\u0176\37\0\1\u0177\33\0\1\u0178\33\0"+
    "\1\u0179\40\0\1\u017a\33\0\1\u017b\33\0\1\u017c\16\0"+
    "\1\u017d\33\0\1\u017e\33\0\1\u017f\47\0\1\u0180\33\0"+
    "\1\u0181\33\0\1\u0182\34\0\1\u0183\33\0\1\u0184\33\0"+
    "\1\u0185\13\0\1\u0186\33\0\1\u0187\33\0\1\u0188\55\0"+
    "\1\u0189\33\0\1\u018a\33\0\1\u018b\20\0\1\u018c\33\0"+
    "\1\u018d\33\0\1\u018e\40\0\1\u018f\33\0\1\u0190\33\0"+
    "\1\u0191\32\0\1\u0192\33\0\1\u0193\33\0\1\u0194\23\0"+
    "\1\u0195\33\0\1\u0196\33\0\1\u0197\27\0\1\u0198\33\0"+
    "\1\u0199\33\0\1\u019a\24\0\2\u019b\1\u019c\3\0\1\u019d"+
    "\33\0\1\u019e\25\0\2\u019f\1\u01a0\3\0\1\u01a1\25\0"+
    "\2\u019b\1\u019c\3\0\1\u01a2\50\0\1\u01a3\13\0\1\u01a4"+
    "\12\0\1\u01a5\3\0\1\u01a6\14\0\1\u01a7\30\0\2\u019f"+
    "\1\u01a0\3\0\1\u01a8\50\0\1\u01a9\13\0\1\u01aa\12\0"+
    "\1\u01ab\33\0\1\u01a5\3\0\1\u01a6\22\0\1\u01ac\40\0"+
    "\1\u01ad\21\0\1\u01ae\55\0\1\u01af\23\0\1\u01b0\33\0"+
    "\1\u01ab\26\0\1\u01b1\40\0\1\u01b2\21\0\1\u01b3\56\0"+
    "\1\u01b4\10\0\1\u01b5\54\0\1\u01b6\26\0\1\u01b7\17\0"+
    "\1\u01b8\56\0\1\u01b9\10\0\1\u01ba\54\0\1\u01bb\33\0"+
    "\1\u01bc\33\0\1\u01bd\6\0\1\u01be\1\0\1\u01bf\4\0"+
    "\1\u01c0\30\0\1\u01c1\54\0\1\u01c2\33\0\1\u01c3\33\0"+
    "\1\u01c4\6\0\1\u01c5\1\0\1\u01c6\4\0\1\u01c7\31\0"+
    "\1\u019b\35\0\1\u019b\23\0\10\u01be\1\u01c0\23\u01be\24\0"+
    "\1\u01c8\10\0\2\u01c9\1\u01ca\3\0\1\u01cb\35\0\1\u01cc"+
    "\1\0\1\u01cd\6\0\1\u01ce\1\0\1\u01cf\1\0\1\u01d0"+
    "\1\u01d1\1\u01d2\1\u01d3\12\0\1\u01d4\31\0\1\u019f\35\0"+
    "\1\u019f\23\0\10\u01c5\1\u01c7\23\u01c5\24\0\1\u01d5\10\0"+
    "\2\u01c7\1\u01d6\3\0\1\u01d7\36\0\1\u01d8\22\0\2\u01c9"+
    "\1\u01ca\3\0\1\u01d9\50\0\1\u01da\13\0\1\u01db\16\0"+
    "\1\u01dc\37\0\1\u01dd\15\0\1\u01de\13\0\1\u01df\22\0"+
    "\1\u01e0\3\0\1\u01e1\45\0\1\u01e2\12\0\1\u01e3\54\0"+
    "\1\u01e4\15\0\1\u01e5\10\0\1\u01e6\26\0\1\u01e7\25\0"+
    "\1\u01e8\45\0\1\u01e9\13\0\1\u01ea\57\0\1\u01eb\7\0"+
    "\1\u01db\41\0\1\u01ec\40\0\1\u01ed\43\0\1\u01ee\35\0"+
    "\1\u01ef\30\0\1\u01f0\30\0\1\u01f1\41\0\1\u01f2\14\0"+
    "\1\u01f3\44\0\1\u01f4\37\0\1\u01f5\16\0\1\u01f6\54\0"+
    "\1\u01f7\31\0\1\u01f8\33\0\1\u01f9\32\0\1\u01fa\15\0"+
    "\1\u01fb\40\0\1\u01fc\42\0\1\u01fd\35\0\1\u01fe\10\0"+
    "\1\u01ff\47\0\1\u0200\32\0\1\u0201\40\0\1\u0202\31\0"+
    "\1\u0203\41\0\1\u0204\31\0\1\u01f0\20\0\1\u01f3\30\0"+
    "\1\u0205\17\0\1\u0206\31\0\1\u0207\24\0\1\u0208\44\0"+
    "\1\u0209\27\0\1\u020a\34\0\1\u020b\35\0\1\u020c\10\0"+
    "\1\u020d\34\0\1\u01be\53\0\1\u020e\33\0\1\u020f\12\0"+
    "\1\u0210\41\0\1\u01f9\20\0\10\u0211\1\0\23\u0211\11\0"+
    "\1\u0212\36\0\1\u0213\35\0\1\u0214\31\0\1\u0202\37\0"+
    "\1\u0215\40\0\1\u0216\33\0\1\u0217\30\0\1\u01f0\17\0"+
    "\1\u01c5\53\0\1\u0218\33\0\1\u0219\13\0\1\u01c9\35\0"+
    "\1\u021a\52\0\1\u01d1\4\0\10\u0211\1\u021b\23\u0211\1\0"+
    "\1\u0202\1\0\1\u021c\4\0\1\u021b\52\0\1\u021d\33\0"+
    "\1\u021e\17\0\1\u021f\44\0\1\u0206\33\0\1\u01cf\15\0"+
    "\1\u01c7\35\0\1\u0220\24\0\2\u021a\1\u0221\3\0\1\u0222"+
    "\50\0\1\u0223\20\0\1\u0202\33\0\1\u0224\33\0\1\u0225"+
    "\46\0\1\u0226\26\0\1\u0227\3\0\1\u0228\22\0\1\u0229"+
    "\36\0\1\u01f0\26\0\1\u022a\35\0\1\u022b\26\0\1\u022c"+
    "\55\0\1\u022d\34\0\1\u022e\33\0\1\u022f\31\0\1\u0230"+
    "\26\0\1\u0231\40\0\1\u0232\33\0\1\u0233\6\0\1\u0234"+
    "\1\0\1\u0235\4\0\1\u01c9\30\0\1\u0236\34\0\1\u0202"+
    "\33\0\1\u021a\25\0\10\u0234\1\u01c9\23\u0234\24\0\1\u0237"+
    "\20\0\1\u0238\1\0\1\u0239\6\0\1\u023a\1\0\1\u023b"+
    "\1\0\1\u023c\1\0\1\u023d\1\u023e\14\0\1\u023f\50\0"+
    "\1\u0240\15\0\1\u0241\13\0\1\u0242\22\0\1\u0243\3\0"+
    "\1\u0244\45\0\1\u0245\12\0\1\u0246\36\0\1\u0247\10\0"+
    "\1\u0248\26\0\1\u0249\43\0\1\u024a\34\0\1\u024b\30\0"+
    "\1\u024c\30\0\1\u024d\41\0\1\u024e\14\0\1\u024f\44\0"+
    "\1\u0250\37\0\1\u0251\37\0\1\u0252\31\0\1\u0253\33\0"+
    "\1\u0254\30\0\1\u0255\25\0\1\u0256\40\0\1\u0257\31\0"+
    "\1\u0258\41\0\1\u0259\31\0\1\u024c\20\0\1\u024f\30\0"+
    "\1\u025a\17\0\1\u025b\22\0\1\u025c\44\0\1\u025d\27\0"+
    "\1\u025e\14\0\1\u0234\40\0\1\u0254\20\0\10\u025f\1\0"+
    "\23\u025f\11\0\1\u0260\36\0\1\u0261\35\0\1\u0262\31\0"+
    "\1\u0257\44\0\1\u0263\33\0\1\u0264\30\0\1\u024c\11\0"+
    "\10\u025f\1\u0265\23\u025f\1\0\1\u0257\1\0\1\u0266\4\0"+
    "\1\u0265\52\0\1\u0267\33\0\1\u0268\30\0\1\u025b\33\0"+
    "\1\u023b\33\0\1\u0269\20\0\1\u0257\33\0\1\u026a\34\0"+
    "\1\u026b\36\0\1\u024c\46\0\1\u026c\31\0\1\u026d\13\0"+
    "\1\u0257\25\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[17080];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\5\0\1\11\1\1\1\11\3\1\66\0\1\11\24\0"+
    "\1\1\50\0\1\11\163\0\1\11\4\0\1\1\6\0"+
    "\1\1\227\0\2\1\1\0\1\1\44\0\1\1\23\0"+
    "\1\11\106\0\1\11\4\0\1\1\11\0\1\11\72\0"+
    "\1\11\10\0";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[621];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** For the backwards DFA of general lookahead statements */
  private boolean [] zzFin = new boolean [Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())+1];

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	Titles() { }
	
	private StringBuilder text = new StringBuilder(); //possibile testo della rubrica
	
	private int meaningfulText = 0;
	
	private int previousMeaningfulText = 0;
	
	private boolean warning = false;


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public Titles(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
            switch (zzLexicalState) {
            case inContainer: {
              //errore se si arriva qua
		
		return YYEOF;
            }  // fall though
            case 622: break;
            default:
        return YYEOF;
        }
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { output.append(yytext());
            }
          // fall through
          case 11: break;
          case 2:
            { text.append(yytext()); meaningfulText++;
            }
          // fall through
          case 12: break;
          case 3:
            { if(text.length() == 0) {
		
			output.append(yytext());
		
		} else {
		
			text.append(yytext());
		}
            }
          // fall through
          case 13: break;
          case 4:
            { if(text.length() == 0) {
		
			output.append(yytext());
		
		} else {
		
			text.append(yytext());
			
			if(previousMeaningfulText == 0) {
			
				previousMeaningfulText = meaningfulText;
			
			} else {
			
				if( !warning && meaningfulText > previousMeaningfulText) {
				
					getMarkerDocument().addWarning("idref:" + getMarkerDocument().getContext().getContainerId() + " Rubrica non ben formattata, verificare");
					
					warning = true;
				}
			}
			
		}
            }
          // fall through
          case 14: break;
          case 5:
            { if(text.length() == 0) {
		
			//gli <h:br> tra intestazione e rubrica possono essere eliminati direttamente
		
		} else {
		
			text.append(yytext());
		}
            }
          // fall through
          case 15: break;
          case 6:
            { if(text.length() > 0) {
			
			output.append("<mrk:rubrica>" + text.toString() + "</mrk:rubrica>");
			
			text = new StringBuilder();
		}
		
		yypushback(yylength());
		
		yybegin(0);
            }
          // fall through
          case 16: break;
          case 7:
            { output.append(yytext());
	
	getMarkerDocument().getContext().updateContainer(yytext());

	text = new StringBuilder();
	
	meaningfulText = 0;
	
	previousMeaningfulText = 0;
	
	warning = false;
	
	yybegin(inContainer);
            }
          // fall through
          case 17: break;
          case 8:
            // general lookahead, find correct zzMarkedPos
            { int zzFState = 2;
              int zzFPos = zzStartRead;
              if (zzFin.length <= zzBufferL.length) {
                zzFin = new boolean[zzBufferL.length+1];
              }
              boolean zzFinL[] = zzFin;
              while (zzFState != -1 && zzFPos < zzMarkedPos) {
                zzFinL[zzFPos] = ((zzAttrL[zzFState] & 1) == 1);
                zzInput = Character.codePointAt(zzBufferL, zzFPos, zzMarkedPos);
                zzFPos += Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              }
              if (zzFState != -1) {
                zzFinL[zzFPos++] = ((zzAttrL[zzFState] & 1) == 1);
              }
              while (zzFPos <= zzMarkedPos) {
                zzFinL[zzFPos++] = false;
              }

              zzFState = 3;
              zzFPos = zzMarkedPos;
              while (!zzFinL[zzFPos] || (zzAttrL[zzFState] & 1) != 1) {
                zzInput = Character.codePointBefore(zzBufferL, zzFPos, zzStartRead);
                zzFPos -= Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              };
              zzMarkedPos = zzFPos;
            }
            { //do nothing, niente testo significativo e partizione successiva rilevata, rubrica assente
	
	output.append(yytext());
            }
          // fall through
          case 18: break;
          case 9:
            { //do nothing, rubrica già presente
	
	output.append(yytext());
            }
          // fall through
          case 19: break;
          case 10:
            // general lookahead, find correct zzMarkedPos
            { int zzFState = 4;
              int zzFPos = zzStartRead;
              if (zzFin.length <= zzBufferL.length) {
                zzFin = new boolean[zzBufferL.length+1];
              }
              boolean zzFinL[] = zzFin;
              while (zzFState != -1 && zzFPos < zzMarkedPos) {
                zzFinL[zzFPos] = ((zzAttrL[zzFState] & 1) == 1);
                zzInput = Character.codePointAt(zzBufferL, zzFPos, zzMarkedPos);
                zzFPos += Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              }
              if (zzFState != -1) {
                zzFinL[zzFPos++] = ((zzAttrL[zzFState] & 1) == 1);
              }
              while (zzFPos <= zzMarkedPos) {
                zzFinL[zzFPos++] = false;
              }

              zzFState = 3;
              zzFPos = zzMarkedPos;
              while (!zzFinL[zzFPos] || (zzAttrL[zzFState] & 1) != 1) {
                zzInput = Character.codePointBefore(zzBufferL, zzFPos, zzStartRead);
                zzFPos -= Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              };
              zzMarkedPos = zzFPos;
            }
            { //do nothing, niente testo significativo e partizione successiva rilevata, rubrica assente
	
	output.append(yytext());
            }
          // fall through
          case 20: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java Titles [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        Titles scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new Titles(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
